# random.pl
# ֘Ȁ

use Math::Random::MT;
use MIME::Base64;

require 'config.txt';

# WFl[^
$rand_gen;

sub init_rand {
	my @seeds = &read_seeds();

	# 킪Ȃ
	if ($#seeds < 0) {
		printf STDERR "No random seeds.\n" if ($verbose_mode);
		exit 1;
	}

	# ̊mFp
	if ($verbose_mode) {
		print STDERR "Random Seeds:\n";
		foreach (@seeds) {
			print STDERR "$_, ";
		}
		print STDERR "\n";
	}

	$rand_gen = Math::Random::MT->new(@seeds);

	# EH[AbviEH[Abv񐔁S̍vj
	my $sum = 0;
	foreach (@seeds) {
		$sum += $_;
	}
	# EH[Abv񐔂̊mFp
	print STDERR "Warming-up Count: $sum\n" if ($verbose_mode);

	for (my $i = 0; $i < $sum; $i++) {
		$rand_gen->rand;
	}
}

# ǂݍ
sub read_seeds {
	my @seeds = ();

	open(SEED, $path_seeds) || die "Failed to open: $path_seeds\n";
	my @bare_seeds = <SEED>;
	close(SEED);

	foreach (@bare_seeds) {
		s/^ID://;
		s/[^A-Za-z0-9+\/]//g;
		next if ($_ eq "");

		$_ = substr($_, 0, 8) if (length > 8);  # 8ɐ
		print STDERR "ID:$_\n" if ($verbose_mode);  # ID̊mFp

		$_ = decode_base64($_);
		@_ = unpack("C*", $_);
		push(@seeds, @_);
	}

	return @seeds;
}

1;
