# test.pl
# eXgp̏

# 퐶pi₱EEEj
$test_rand;

# JE^
# $test_total x $test_total ̂Qzî悤ɈPzj
# $test_count[$i * $test_total + $j]
#   $i : Vbẗʒu
#   $j : VbtÖʒu
@test_count;

# Vbt̃eXg
sub test_shuffle {
	&test_set_config();
	&test_init_rand();
	&test_init_characters();
	&test_init_count();

	for (my $i = 0; $i < $test_trial_num; $i++) {
		print STDERR ("$i/$test_trial_num\n") if ($i % 1000 == 0);
		&test_change_seeds();
		&shuffle_main();
		&test_count();
	}
	print STDERR ("$test_trial_num/$test_trial_num\n");

	&test_check_count();
}

# ݒ̕ύX
sub test_set_config {
	# ԏԂo͂Ȃ
	$verbose_mode = 0;

	# eXgp̃LN^[ɍ킹
	# ̓Vbt̓xɊ֌WȂ̂
	# ȒP̂߂PubNPɂĂ܂
	@block_name = ('A');
	$char_per_match = $test_total;
	$match_per_block = 1;
}

# 퐶p̏i₱EEEj
sub test_init_rand {
	$test_rand = Math::Random::MT->new(1);
	for (my $i = 0; $i < 10000; $i++) {
		$test_rand->rand(1);
	}
}

# LN^[̏i0..($test_total-1)ނj
sub test_init_characters {
	open(CHR, ">$path_characters");
	for (my $i = 0; $i < $test_total; $i++) {
		print CHR "$i\n";
	}
	close(CHR);
}

# _ɕύX
sub test_change_seeds {
	open(ID, ">$path_seeds");
	for (my $i = 0; $i < $test_seed_num; $i++) {
		# ID𐶐
		@_ = ();
		for (my $j = 0; $j < 6; $j++) {
			push(@_, int($test_rand->rand(256)));
		}
		$_ = pack("C*", @_);
		$_ = encode_base64($_);
		print ID ("$_");
	}
	close(ID);
}

# JE^
sub test_init_count {
	@test_count = (0) x ($test_total * $test_total);
}

# JEg
sub test_count {
	open(BRA, "$path_brackets");
	my $i = 0;
	foreach (<BRA>) {
		$_ =~ / ([0-9]+)\s*$/;
		$test_count[$i * $test_total + $1]++;
		$i++;
	}
	close(BRA);
}

# JEg`FbN
sub test_check_count {
	open(TEST, ">$test_path_result");

	# sΕU
	my $avr  = $test_trial_num / $test_total;
	my $min  = $test_trial_num;
	my $max  = 0;
	my $chi2 = 0;
	for (my $i = 0; $i <= $#test_count; $i++) {
		$_ = $test_count[$i];
		$min = $_ if ($_ < $min);
		$max = $_ if ($_ > $max);
		$_ -= $avr;
		$_ *= $_;
		$chi2 += $_;
	}
	$chi2 /= $avr;

	my $format = <<EOS;
min = %d
max = %d
avr = %.16E
chi^2 = %.16E
EOS
	printf TEST ($format, $min, $max, $avr, $chi2);
	printf($format, $min, $max, $avr, $chi2);

	for (my $i = 0; $i < $test_total; $i++) {
		for (my $j = 0; $j < $test_total; $j++) {
			printf TEST ("%3d %3d %6d\n", $i, $j, $test_count[$i * $test_total + $j]);
		}
	}
	close(TEST);
}

1;
